﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Util;

namespace 子进程
{
    public partial class IpcTestForm : Form
    {
        public IpcTestForm()
        {
            InitializeComponent();
        }

        private void IpcTestForm_Load(object sender, EventArgs e)
        {
            /// ★★★★★★ 请填写登陆器里的sock服务端端口号
            int ipcSockPort = 12345;

            if (KssModule.IPC_Connect(ipcSockPort) == 0)
            {
                MessageBox.Show("连接登陆器失败");
            }
        }

        /// <summary>
        /// advapi测试1   ks_advapi (“v_geta”)
        /// </summary>
        private void button1_Click(object sender, EventArgs e)
        {
            // 显示测试结果 这里用的示例接口 v_geta 弹出返回值
            MessageBox.Show(KssModule.advapi("v_geta", InvokeMode.IPC));
        }

        /// <summary>
        /// advapi测试2   
        /// ks_advapi (“v_getb,100,200”) 
        /// [首次连网并缓存，二次缓存获取     
        /// </summary>
        private void button2_Click(object sender, EventArgs e)
        {
            ///  显示测试结果  这里用的示例接口 v_getb 弹出返回值
            MessageBox.Show(KssModule.advapi("v_getb,100,200", InvokeMode.IPC));
        }

        /// <summary>
        /// 频率验证测试
        /// </summary>
        private void button3_Click(object sender, EventArgs e)
        {
            /// chkPass函数在 _ks1程序集里，其实就是对验证模块接口ks_CheckKeyE的一个包装（因为ks_CheckKeyE要结合signData数据一起使用）
            KssModule.chkPass(0, InvokeMode.IPC);
            MessageBox.Show("频率验证--通过");/// 显示测试结果
        }

        /// <summary>
        /// 强制验证测试
        /// </summary>
        private void button4_Click(object sender, EventArgs e)
        {
            /// chkPass函数在 _ks1程序集里，其实就是对验证模块接口ks_CheckKeyE的一个包装（因为ks_CheckKeyE要结合signData数据一起使用）
            KssModule.chkPass(1, InvokeMode.IPC);
            MessageBox.Show("强制验证--通过");/// 显示测试结果
        }

        /// <summary>
        /// ks_GetData测试
        /// </summary>
        private void button5_Click(object sender, EventArgs e)
        {
            string vbCrLf = Environment.NewLine;
            string result = string.Empty;
            result = "ks_GetData所有序数据" + vbCrLf + vbCrLf;
            result = result + "IPC_GetData(0)【验证次数】：" + KssModule.IPC_GetData(0) + vbCrLf;
            result = result + "IPC_GetData(1)【返回信息A】：" + KssModule.IPC_GetData(1) + vbCrLf;
            result = result + "IPC_GetData(2)【返回信息B】：" + KssModule.IPC_GetData(2) + vbCrLf;
            result = result + "IPC_GetData(3)【用户附属性】：" + KssModule.IPC_GetData(3) + vbCrLf;
            result = result + "IPC_GetData(4)【绑定信息】：" + KssModule.IPC_GetData(4) + vbCrLf;
            result = result + "IPC_GetData(5)【剩余时间】：" + KssModule.IPC_GetData(5) + vbCrLf;
            result = result + "IPC_GetData(6)【软件下载地址】：" + KssModule.IPC_GetData(6) + vbCrLf;
            result = result + "IPC_GetData(7)【用户通道数】：" + KssModule.IPC_GetData(7) + vbCrLf;
            result = result + "IPC_GetData(8)【服务端软件版本】：" + KssModule.IPC_GetData(8) + vbCrLf;
            result = result + "IPC_GetData(9)【更新日志URL】：" + KssModule.IPC_GetData(9) + vbCrLf;
            result = result + "IPC_GetData(10)【用户天数】：" + KssModule.IPC_GetData(10) + vbCrLf;
            result = result + "IPC_GetData(11)【服务端时间戮】：" + KssModule.IPC_GetData(11) + vbCrLf;
            result = result + "IPC_GetData(12)【用户剩余点数】：" + KssModule.IPC_GetData(12) + vbCrLf;
            result = result + "IPC_GetData(13)【用户标签】：" + KssModule.IPC_GetData(13) + vbCrLf;
            result = result + "IPC_GetData(14)【用户充值次数】：" + KssModule.IPC_GetData(14) + vbCrLf;
            result = result + "IPC_GetData(15)【返回的域名】：" + KssModule.IPC_GetData(15) + vbCrLf;
            result = result + "IPC_GetData(16)【是否可单机多开】：" + KssModule.IPC_GetData(16) + vbCrLf;
            result = result + "IPC_GetData(17)【用户名】：" + KssModule.IPC_GetData(17) + vbCrLf;
            result = result + "IPC_GetData(18)【是否公用帐号】：" + KssModule.IPC_GetData(18) + vbCrLf;
            result = result + "IPC_GetData(19)【是否检查登陆标识】：" + KssModule.IPC_GetData(19) + vbCrLf;

            MessageBox.Show(result); // 显示测试结果

        }

        /// <summary>
        /// 扣点测试
        /// </summary>
        private void button6_Click(object sender, EventArgs e)
        {
            int result = 0;
            string errinfo = string.Empty;
            result = KssModule.kpoints(3, errinfo, InvokeMode.IPC);  // 记录错误变量是传址的，扣点出错时该变量值会记录错误信息
            if (result == -1)    /// 扣点失败
            {
                MessageBox.Show(errinfo);
                /// 扣点失败，你可以根据据错误提示，来进行相应的处理，我这里只是关闭程序
                /// this.Close();
            }
            MessageBox.Show("扣点成功，用户剩余点数" + result.ToString());  /// 显示测试结果
        }

        /// <summary> 
        /// advapi测试3
        /// ks_advapi (“v_getb,100,200”)
        /// 先清除缓存，然后连网获取
        /// </summary>
        private void button7_Click(object sender, EventArgs e)
        {
            /// 删除缓存，以便下次调用相应advapi时重新连接服务器，从服务器获取最新数据
            KssModule.ks_advapifree("v_getb,100,200");
            /// 显示测试结果  这里用的示例接口 v_getb 弹出返回值  '
            MessageBox.Show(KssModule.advapi("v_getb,100,200", InvokeMode.IPC));
        }

    }
}
